﻿-- Author      : Nogarder
-- Create Date : 2013/4/17 13:42:52
--register initialize function
--NPA.DataCollector.RegisterModule( datatype, initfunc, uninitfunc )
NPA.DataCollector.RegisterModule("Summoned",
	function()
		local NPA_SpellInfo_GetSpellInfo=NPA.SpellInfo.GetSpellInfo
		local NPA_EventHandler_FireEvent=NPA.EventHandler.FireEvent
		local NPA_DataCollector_GetUnitDataByGUID=NPA.DataCollector.GetUnitDataByGUID
		--
		local OnSummoned=function(_,sourceunitdata,destunitdata)
			if(not sourceunitdata.Summon)then
				sourceunitdata.Summon={
					[destunitdata.GUID]=true
				}
			else
				sourceunitdata.Summon[destunitdata.GUID]=true
			end

			destunitdata.SummonedBy=spellid
			destunitdata.SummonedByUnitData=sourceunitdata
			--fire event
			NPA_EventHandler_FireEvent(7,"Summoned_Updated",destunitdata)
			--fire event
			NPA_EventHandler_FireEvent(7,"Summoned_Updated",sourceunitdata)
		end
		--
		local OnDestroyed=function(_,_,destunitdata)
			--remove the summoned link
			local sourceunitdata=NPA_DataCollector_GetUnitDataByGUID(destunitdata.SummonedBy)
			if(sourceunitdata)then
				sourceunitdata.Summon[destunitdata.GUID]=nil
				--fire event
				NPA_EventHandler_FireEvent(7,"Summoned_Updated",sourceunitdata)
			end
			destunitdata.SummonedBy=nil
			--fire event
			NPA_EventHandler_FireEvent(7,"Summoned_Updated",destunitdata)
		end
		--combatlog event
		NPA.DataCollector.RegisterCombatLogEvent("SPELL_SUMMON","DataCollector_Summoned",OnSummoned)
		NPA.DataCollector.RegisterCombatLogEvent("SPELL_CREATE","DataCollector_Summoned",OnSummoned)
		---
		NPA.DataCollector.RegisterCombatLogEvent("UNIT_DESTROYED","DataCollector_Summoned",OnDestroyed)
		NPA.DataCollector.RegisterCombatLogEvent("UNIT_DIED","DataCollector_Summoned",OnDestroyed)
	end,
	function()
		--unregister events
		NPA.DataCollector.RegisterCombatLogEvent("SPELL_SUMMON","DataCollector_Summoned",nil)
		NPA.DataCollector.RegisterCombatLogEvent("SPELL_CREATE","DataCollector_Summoned",nil)
		NPA.DataCollector.RegisterCombatLogEvent("UNIT_DESTROYED","DataCollector_Summoned",nil)
		NPA.DataCollector.RegisterCombatLogEvent("UNIT_DIED","DataCollector_Summoned",nil)
	end,
	--data transfer function,transfer frame-based unitdata to guid-based unitdata
	--frame-based won't get any data so dont do transfer
	function()
		--
		--do nothing
	end
	)

