﻿-- Author      : Nogarder
-- Create Date : 2013/4/2 13:50:27
local table_getn=table.getn
local NPA_NamePlateDataParser_AddElements=NPA.NamePlateDataParser.AddElements

local NPA_IconGroupManager_ClearIconGroup=NPA.IconGroupManager.ClearIconGroup
local NPA_IconGroupManager_InsertIcon=NPA.IconGroupManager.InsertIcon
local NPA_IconGroupManager_UpdateGroup=NPA.IconGroupManager.UpdateGroup

--filter cache
local NPA_IconGroup_FilterCache={}
--
NPA.NamePlateModuleManager.RegisterDataModule("IconGroup","Aura",function(framedata,icongroup,setting)
	--build filtercache
	if(not NPA_IconGroup_FilterCache[framedata])then
		NPA_IconGroup_FilterCache[framedata]={}
	end
	local filtercache=NPA_IconGroup_FilterCache[framedata]
	--add event elements
 	--name update
	NPA_NamePlateDataParser_AddElements(framedata,icongroup,"Aura_Updated",function(framedata,unitdata)
		local auras=unitdata.Aura
		if(auras)then
			--clear
			NPA_IconGroupManager_ClearIconGroup(icongroup)
			local spelllist={}
			local playerguid=UnitGUID("player")
			for i=1,table_getn(auras)do
				local aura=auras[i]
				--filters
				if(aura.SpellId)then
					for _,rule in pairs(setting.DataRules)do
						--from type filter
						if(rule.FromType==1 or (rule.FromType==2 and aura.CasterGUID==playerguid))then
							--aura filter
							if((rule.FilterType==1 and aura.Sort=="Buff") or --buff
								(rule.FilterType==2 and aura.Sort=="Debuff") or --debuff
								(rule.FilterType==3 and rule.SpellList[aura.SpellId]==true) or --spell list
								(rule.FilterType==4 and rule.SchoolList[aura.SpellType]==true) --school list
							)then
								--same aura could match multiple rules, using the one which has higher priority
								--not exist or has lower priority
								if(not spelllist[i] or spelllist[i].Priority<rule.Priority)then
									spelllist[i]=rule
								end
							end
						end
					end
				end
			end
			--insert icons
			for index,rule in pairs(spelllist)do
				local aura=auras[index]
				--NPA.IconGroupManager.InsertIcon=function(icongroup,starttime,endtime,spellid,iconsetting)
				NPA_IconGroupManager_InsertIcon(icongroup,aura.AppliedTime,aura.ExpirationTime,aura.SpellId,aura.SpellType,aura.Count,rule)
			end
			--insert aura
			--force an update
			NPA_IconGroupManager_UpdateGroup(icongroup)
		else
			icongroup:Hide()
		end
	end)
end)
